@echo off
setlocal
if ABC==ABC (
set TestVar=123
if not !TestVar!==123 cmd /v:on /e:on /c %0 %*
if not !TestVar!==123 goto End
)

echo.
echo NTP Tester.
echo ============
echo Get list from command line and produce results in format:  Status, Trace errors, Hops, Average Time, HostName.
echo List can be obtained from http://support.ntp.org/bin/view/Servers/StratumTwoTimeServers
echo Table must be saved in txt file
if exist "%~n1_Unsorted.txt" del "%~n1_Unsorted.txt"
if exist "%~n1_SortedByErrors.txt" del "%~n1_SortedByErrors.txt"

echo.
echo Status, Trace errors, Hops, Average Time, HostName
echo --------------------------------------------------------
for /f "tokens=2,3" %%a in (%1) do ( 
	echo %%a|findstr /c:. >nul
	if !errorlevel! equ 0 (set HostName=%%a) else (set HostName=%%b)
	set SumTimeOut=0
	set Hops=0
	set Errors=0
	set Status=Failed
	
	for /f "usebackq tokens=1,2,3" %%c in (`ftrace -d -w 2000 -i 1 !HostName!`) do for /f "delims=m tokens=1,2" %%j in ("%%d") do (
		if %%c LSS 900 (
rem		echo %%c	 %%d	%%e
			if not %%j==* if %%k==s ( 
				set /a SumTimeOut=!SumTimeOut!+%%j
				set /a Hops=!Hops!+1
				)
				rem  end of "if not %%j==* if %%k==s"
			if %%j==* set /a Errors=!Errors!+1
			)
			rem End of "if %%c LSS 900"
		)
		rem end of "for /f "usebackq tokens=1,2,3" %%c in..."
	 if !Hops! neq 0 (
	 	 set /a AverageTime=!SumTimeOut! / !Hops!

		 if !AverageTime! LSS 1000 if !AverageTime! LSS 100 (if !AverageTime! LSS 10 (set AverageTime=000!AverageTime!) else (set AverageTime=00!AverageTime!)) else (set AverageTime=0!AverageTime!)
		 if !Hops! LSS 1000 if !Hops! LSS 100 (if !Hops! LSS 10 (set Hops=000!Hops!) else (set Hops=00!Hops!)) else (set Hops=0!Hops!)
		 if !Errors! LSS 1000 if !Errors! LSS 100 (if !Errors! LSS 10 (set Errors=000!Errors!) else (set Errors=00!Errors!)) else (set Errors=0!Errors!)

		 for /f "usebackq delims=1 tokens=*" %%k in (`"cmdtime3.exe /T !HostName!|findstr /c:="`) do set Status=Passed
		 
		 echo !Status!, !Errors!, !Hops!, !AverageTime!, !HostName!
		 echo !Status!, !Errors!, !Hops!, !AverageTime!, !HostName!>>"%~n1_Unsorted.txt"
		 ) else (echo Skipped: Zero hops for "!HostName!")
		 rem End of if !Hops! neq 0
	 )
	 rem end of "for /f %%a in......"
echo Sorting....
sort "%~n1_Unsorted.txt" >"%~n1_SortedByErrors.txt"

:End
endlocal